package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.print.strategy;

import cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.print.IPrintTemplateStrategyService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionPsOutContext;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MesProduceSnPrintDataModel;
import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.mes.pcn.api.iservice.base.IConfigService;
import cn.estsh.i3plus.pojo.mes.bean.MesConfig;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2024/6/17 16:31
 * @Modify:
 **/
@Service
@Slf4j
public class NoSortBarCodeGzStrategy implements IPrintTemplateStrategyService {
    @Autowired
    private IConfigService configService;
    @Override
    public MesProduceSnPrintDataModel execute(StepResult stepResult,StationRequestBean reqBean, MesProductionPsOutContext sn, String organizeCode) {
        //获取供应商编码
        MesConfig mesConfig = configService.getMesConfigByCfgCodeKeyOrg(MesPcnExtConstWords.SUPPLIER_CODE, MesPcnExtConstWords.SUPPLIER_CODE_NO_SORT_GZ, reqBean.getOrganizeCode());
        if (null == mesConfig) {
            stepResult.setCompleted(false);
            stepResult.setMsg(String.format("缺少供应商编码配置,请配置系统参数,配置代码【%s】,配置key为【%s】", MesPcnExtConstWords.SUPPLIER_CODE,MesPcnExtConstWords.SUPPLIER_CODE_NO_SORT_GZ));
            return null;
        }
        String supplierCode = mesConfig.getCfgValue();
        //1.根据零件号获取 零件扩展信息
        Map<String,Object> map = new HashMap<>();
        String partNo = sn.getPartNo();
        String partName = sn.getPartName();
        String factoryName = reqBean.getOrganizeName();
        String productSn = sn.getProductSn();
        LocalDateTime now = LocalDateTime.now();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        String productDateTime = now.format(formatter);

        MesProduceSnPrintDataModel model = new MesProduceSnPrintDataModel();
        model.setPartNo(partNo);
        model.setPartName(partName);
        model.setFactoryName(factoryName);
        model.setSupplierCode(supplierCode);
        model.setProductDate(productDateTime);
        model.setNo( productSn.substring(productSn.length()-4));
        model.setBarcode(productSn);
        return model;
    }
}
