package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.strategy.numberrule.strategy;

import cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.strategy.numberrule.INumberRulePackAttributeStrategy;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MesNumberRuleStrategyModel;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.pojo.mes.model.GenSerialNoModel;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2024/6/26 9:38
 * @Modify:
 **/
@Component
public class XiaoPengNumberRuleStrategy implements INumberRulePackAttributeStrategy {


    @Override
    public GenSerialNoModel execute(MesNumberRuleStrategyModel model) {
        Date date = new Date();
        // XIAO_PENG 原客户条码.小鹏汽车 NoSortBarCodeGZ-new
        //{custPartNo}{SPILTRULE}{year}{month}{day}{hour}{minute}{second}{serialNo}
        GenSerialNoModel genSerialNoModel = new GenSerialNoModel();
        genSerialNoModel.setRuleCode(model.getSnRule());
        //客户零件号
        String custPartNo = model.getCustPartNo();
        genSerialNoModel.setCustPartNo(custPartNo);
        //日期${dateShort}
        genSerialNoModel.setYear(getYearShort(date));
        genSerialNoModel.setMonth(getMonthShort(date));
        genSerialNoModel.setDay(getDayShort(date));
        //中杠 -
        //生产日期 + 时间 yyyyMMddHHmmss
        //流水号 5位 每天从1开始
        return genSerialNoModel;
    }

    private String getYearShort(Date date) {
        return MesExtEnumUtil.YEAR_SHORT.valueOfDescription(Integer.parseInt(TimeTool.getYear(date)));
    }

    private String getMonthShort(Date date) {

        return MesExtEnumUtil.MONTH_SHORT.valueOfDescription(Integer.parseInt(TimeTool.getMonth(date)));
    }

    private String getDayShort(Date date) {
        return TimeTool.getDay(date);
    }
}
